/*
{
    "author": "",
    "color": "lightpink",
    "movement": true,
    "parameters": [
        {
            "default": 0.5,
            "name": "x"
        },
		{
            "default": 0.5,
            "name": "y"
        },
		{
            "default": 0.5,
            "name": "lurm",
			"min": 0.4
        },
		{
            "default": 0.5,
            "name": "yep",
			"min": 0.4
        }
    ],
    "url": "",
    "uuid": "0c61882b-5ebd-41d9-97f6-a4f217da52c3"
}
*/

#ifdef GL_ES
precision highp float;
#endif

//uniform float time;
//uniform vec2 mouse;
//uniform vec2 resolution;

vec2 hash(vec2 p)
{
    mat2 m = mat2(
	3.85, 47.77,
	99.41, 98.48
    );

    return fract(sin(m * p) * 78.29);
}

float voronoi(vec2 p)
{
    vec2 g = floor(p);
    vec2 f = fract(p);

    float distanceToClosestFeaturePoint = 6.0;
    for(int y = -1; y <= 1; y++)
    {
        for(int x = -1; x <= 1; x++)
        {
            vec2 latticePoint = vec2(x, y);
            float currentDistance = distance(latticePoint + hash(g+latticePoint), f);
            distanceToClosestFeaturePoint = min(distanceToClosestFeaturePoint, currentDistance);
        }
    }

    return distanceToClosestFeaturePoint*lurm;
}

void main( void )
{
	float div = resolution.x/resolution.y;
	vec2 aspect = vec2(1., div);
	vec2 uv = texCoord*aspect-vec2(x, y*div);

   // vec2 uv = ( gl_FragCoord.xy / resolution.xy ) * 2.0 - 1.0;
    uv.x *= resolution.x / resolution.y;

    float offset = voronoi(uv*10.0 + vec2(time));
    float t = 1.0/abs(((uv.x + sin(uv.y + time)) + offset*yep) * 90.0);

    float r = voronoi( uv * 1.0 ) * 10.0;
    vec3 finalColor = vec3(190.0 * uv.y, 28.0, 5.0 * r) * t;
    
    gl_FragColor = vec4(finalColor*color.rgb*opacity, alpha );
}

