/*
{
    "author": "",
    "color": "purple",
    "movement": true,
    "parameters": [
		{
			"default": 0.5,
			"name": "x"
		},
		{
			"default": 0.5,
			"name": "y"
		},
		{
			"default": 0.5,
			"name": "dook",
			"min": 0.1
		},
		{
			"default": 0.5,
			"name": "murf",
			"min": 0.1
		}
    ],
    "url": "",
    "uuid": "3f824a1a-2001-43c7-89e9-6a7449b1e2c1"
}
*/




#ifdef GL_ES
precision highp float;
#endif


//uniform float time;
//uniform vec2 mouse;
//uniform vec2 resolution;


float map(vec3 p)
{
    const int MAX_ITER = 10;
    const float BAILOUT=4.0;
    float Power=6.0;

    vec3 v = p;
    vec3 c = v;

    float r=0.0;
    float d=1.0;
    for(int n=0; n<=MAX_ITER; ++n)
    {
        r = length(v);
        if(r>BAILOUT) break;

        float theta = acos(v.z/r);
        float phi = atan(v.y, v.x);
        d = pow(r,Power-1.0)*Power*d+1.0;

        float zr = pow(r,Power);
        theta = theta*Power;
        phi = (phi*murf)*Power;
        v = (vec3(sin(theta)*cos(phi), sin(phi)*sin(theta), cos(theta))*zr)+c;
    }
    return 0.5*log(r)*r/d;
}


void main( void )
{
	float div = resolution.x/resolution.y;
	vec2 aspect = vec2(1.,div);
	vec2 pos = texCoord*aspect-vec2(x*2.0, y*2.0*div);
    //vec2 pos = (gl_FragCoord.xy*2.0 - resolution.xy) / resolution.y;
    vec3 camPos = vec3(cos(time*0.3), sin(time*0.3), 1.5);
    vec3 camTarget = vec3(0.0, 0.0, 0.0);

    vec3 camDir = normalize(camTarget-camPos);
    vec3 camUp  = normalize(vec3(0.0, 1.0, 0.0));
    vec3 camSide = cross(camDir, camUp);
    float focus = 1.8;

    vec3 rayDir = normalize(dook*camSide*pos.x + camUp*pos.y + camDir*focus);
    vec3 ray = camPos;
    float m = 0.0;
    float d = 0.0, total_d = 0.0;
    const int MAX_MARCH = 50;
    const float MAX_DISTANCE = 1000.0;
    for(int i=0; i<MAX_MARCH; ++i) {
        d = map(ray);
        total_d += d;
        ray += rayDir * d;
        m += 1.0;
        if(d<0.001) { break; }
        if(total_d>MAX_DISTANCE) { total_d=MAX_DISTANCE; break; }
    }

    float c = (total_d)*0.0001;
    vec4 result = vec4( 1.0-vec3(c, c, c)*color.rgb*opacity - vec3(0.025, 0.025, 0.02)*m*0.8/color.rgb*opacity, alpha );
    gl_FragColor = result;
}
