/*
{
    "author": "",
    "color": "#darkblue",
    "movement": true,
    "parameters": [
		{
			"default": 0.5,
			"name": "x"
		},
		{
			"default": 0.5,
			"name": "y"
		},
		{
			"default": 0.5,
			"name": "pul"
		},
		{
			"default": 0.8,
			"name": "morph"
		}

		
    ],
    "url": "",
    "uuid": "02fa3b29-8f04-42b0-b7de-f625efdc3b53"
}
*/

#ifdef GL_ES
precision highp float;
#endif

 //generic rotation formula
vec2 rot(vec2 uv,float a){
	return vec2(uv.x*cos(a)-uv.y*sin(a),uv.y*cos(a)+uv.x*sin(a));
}

float field(in vec3 p) {
	
float strength = 7. + .03 * log(1.e-6 +  ((sin(time)+1.) * 4373.11));
float accum = 0.;
float prev = 0.;
float tw = 0.;
for (int i = 0; i < 24; ++i) {
float mag = dot(p, p);
p = abs(p) / mag + vec3(-.5, -.4, -1.5);
p += float(i)*.02;
float w = exp(-float(i) / 7.);
accum += w * exp(-strength * pow(abs(mag - prev), 2.1));
tw += w;  prev = mag;
}
return max(0., 5. * accum / tw - .7);
}

void main() {

	float div = resolution.x/resolution.y;
	vec2 aspect = vec2(1.,div);
	vec2 uv = texCoord*aspect-vec2(x,y*div);

	//vec2 uv = 2. * gl_FragCoord.xy / resolution.xy - 1.;
	
	//uv.x = abs(-sin(uv.x));
	
	
// make the right ratio!
	vec2 uvs = uv * resolution.xy / max(resolution.x, resolution.y);
	
// slight rotation	
	uvs = rot(uvs,time*.01);	
	
// slight motion	
	float zmotion = abs(sin(time*.014*morph)+1.)*.4 + abs(sin(time*.0121)+1.)*.2;
	float xmotion = abs(sin(time*.024)+1.)*.14  ;
    float ymotion = abs(cos(time*.034)+1.)*.1; 
	
	float zoom = sin(time*.04*pul)*3.+6.; 
	
	
	vec3 p = vec3(uvs / zoom, 0) + vec3(xmotion, ymotion, zmotion*morph );
 
	float t = field(p);
	float v = (1. - exp((abs(uv.x) - 1.) * 6.)) * (1. - exp((abs(uv.y) - 1.) * 6.));

// just make smoothstep
	t = smoothstep(-.01,.7,t);
	
	gl_FragColor =  vec4(vec3(t*color.rgb*opacity),alpha);//    mix(.4, 1., v) * vec4(0.8 * t * t * t, 1.4 * t * t, t, 1.0);
}
