/*
{
    "author": "",
    "color": "violet",
    "movement": true,
    "parameters": [
        {
            "default": 0.5,
            "name": "x"
        },
        {
            "default": 0.5,
            "name": "y"
        },
        {
            "default": 0.4,
            "name": "thick"			
		},
        {
            "default": 0.15,
            "name": "spread",
            
            "max": 0.2
        }
    ],
    "url": "",
    "uuid": "19331196-ffff-4c6b-8a9d-78b29d1db557"
}
*/

#ifdef GL_ES
precision mediump float;
#endif  

  
 
#define count 22.
 
 //generic rotation formula
vec2 rot(vec2 uv,float a){
	return vec2(uv.x*cos(a)-uv.y*sin(a),uv.y*cos(a)+uv.x*sin(a));
}
 
// generic rand return
float rand(float n){
 	return fract(cos(n*89.42)*343.42);
}
 
void main( void ) {
    float div = resolution.y/resolution.x;
    vec2 aspect = vec2(1.,div);

	vec2 uv = texCoord*aspect -vec2(0.5, 0.5*div) ;
	
	uv.x *= resolution.x/resolution.y;
	
	uv = rot(uv,time*.01);
 
	float spread = spread;
	float thickness = thick;
	float wobble_freq = .15;
	float wobble_ampl = .15;
	float t = time*.6;
	
	
	vec3 col = vec3(0.0);
	float s = 0.;
	
	for(float i=0.;i<count;i++){
	
		// individual wobble here
		uv.x += sin(t * uv.y * wobble_freq*.01 + t * i*.21 + i*.3 ) * wobble_ampl;
		
		// todo > eliminate ugly unision phase when sin becomes max ?!?
		
		// make them all move slightly
		uv.x += cos(t + i*uv.y * wobble_freq*.81)*.02;
		
		// offset each line
		uv.x +=	i*spread - spread*count*.4;
	
		s += abs( .01 / uv.x* (thickness+i*.02+.02));
	}
 
	// emboss
	s = smoothstep(.99,.2,s)-.1;
	
	// lowkey dithering :)
	s -= rand(uv.x)*.06;
	
	
	
	 float vig = uv.x*uv.y * 15.0; 
	 //vig = pow(vig, 0.25);
	s+=vig*.01-.2;
	
	
	
	gl_FragColor = vec4(s*color.rgb*opacity, alpha);
 
}