/*
{
    "author": "",
    "color": "#pink",
    "movement": true,
    "parameters": [
		{
			"default": 0.5,
			"name": "x"
		},
		{
			"default": 0.5,
			"name": "y"
		},
		{
			"default": 0.2,
			"name": "woof",
			"min": 0.05
		},
		{
			"default": 0.5,
			"name": "yarf"
		}
	
    ],
    "url": "",
    "uuid": "c0b13600-6d90-492d-a6ad-1e799006b299"
}
*/

#ifdef GL_ES
precision highp float;
#endif

//uniform float time;
//uniform vec2 mouse;
//uniform vec2 resolution;
vec2 hash2( vec2 p )
{
    // procedural white noise	
	return fract(sin(vec2(dot(p,vec2(127.1,311.7)),dot(p,vec2(269.5,183.3))))*43758.5453);
}
// Voronoi (IQ) - slightly modified to return get the ID etc.
vec4 VoronoiGrid( in vec2 x, out vec2 id )
{
    vec2 n = floor(x);
    vec2 f = fract(x);

    // first pass: regular voronoi
	vec2 mg, mr;

    float md = 8.0;
    for( int j=-1; j<=1; j++ )
    for( int i=-1; i<=1; i++ )
    {
        vec2 g = vec2(float(i),float(j));
		vec2 o = hash2( n + g );
        vec2 r = g + o - f;
        float d = dot(r,r);
        if( d<md )
        {
            md = d;
            mr = r;
            mg = g;
        }
    }
    
    // second pass: distance to borders
    md = 8.0;
    for( int j=-2; j<=2; j++ )
    for( int i=-2; i<=2; i++ )
    {
        vec2 g = mg + vec2(float(i),float(j));
		vec2 o = hash2( n + g );
        vec2 r = g + o - f;

        if( dot(mr-r,mr-r)>0.00001 )
        md = min( md, dot( 0.5*(mr+r), normalize(r-mr) ) );
    }
    
    id = (n+mg)+vec2(0.5); // ID is n+mg
    return vec4(md, length(mr), mr);
}

mat2 rotate(float a)
{
	float c = cos(a);
	float s = sin(a);
	return mat2(c/woof, s, -s, c*woof);
}
vec2 smoothRot(vec2 p,float s,float m,float c,float d)
{
  s*=0.5;
  float k=length(p);
  float x=asin(sin(atan(p.x,p.y)*s)*(1.0-m))*k;
  float ds=k*s;
  float y=mix(ds,2.0*ds-sqrt(x*x+ds*ds),c);
  return vec2(x/s,y/s-d*yarf);
}
void main( void )
{
	float div = resolution.x/resolution.y;
	vec2 aspect = vec2(1.,div);
	vec2 pp = texCoord*aspect-vec2(x, y*div);
	
	//vec2 pp = (gl_FragCoord.xy - 0.5 * resolution.xy) / resolution.y;

	pp*=rotate(sin(1.4/length(pp*32.0)+time)+time*0.2);
	pp *= 13.5;

	pp = smoothRot(pp,14.0,.0025,8.0,sin(time)*4.0);
	
	
	float t = time*0.5;
	float nt = 0.5+sin(t*.4)*0.5;
    	vec2 id;
    	float scale = 6.0;
    	vec4 grid = VoronoiGrid(pp*scale,id);
	    pp = id/scale;
	
	pp.x += sin(pp.y*1.0)*1.44;
	
	
	float d1 = abs(sin(pp.x*1.+t*0.7));
	float d2 = abs(sin(pp.x*1.3+t*0.7));
	float d3 = abs(sin(pp.x*1.6+t*0.7));
	
	float dd = length(vec3(d1,d2,d3))*0.55;
	
	vec3 col = vec3(pp.x+d2,pp.x*0.25+d1,d3*0.15+d2)*dd;
	col = col.yzx;
	
	gl_FragColor = vec4( col*color.rgb*opacity, alpha );
}
